diff --git a/examples/systemd/hive-web.service b/examples/systemd/hive-web.service
new file mode 100644
index 00000000..812d72c7
--- /dev/null
+++ b/examples/systemd/hive-web.service
@@ -0,0 +1,15 @@
+[Unit]
+Description=Hive local web UI
+After=network.target hive-daemon.service
+StartLimitBurst=3
+StartLimitIntervalSec=300
+
+[Service]
+Type=simple
+ExecStart=/usr/bin/env hive web
+Restart=on-failure
+RestartSec=10
+Environment=PATH=%h/.local/bin:/usr/local/bin:/usr/bin:/bin
+
+[Install]
+WantedBy=default.target
diff --git a/hive.gemspec b/hive.gemspec
index e54a3dec..907b9dcd 100644
--- a/hive.gemspec
+++ b/hive.gemspec
@@ -40,6 +40,7 @@ Gem::Specification.new do |spec|
     "schemas/**/*.json",
     "examples/systemd/*",
     "examples/launchd/*",
+    "hive.gemspec",
     "install.md",
     "CHANGELOG.md",
     "LICENSE",
@@ -60,6 +61,7 @@ Gem::Specification.new do |spec|
   spec.add_dependency "faraday", ">= 2.14.2", "< 3.0"
   spec.add_dependency "faraday-multipart", "~> 1.0"
   spec.add_dependency "lipgloss", "~> 0.2.2"
+  spec.add_dependency "rexml", "~> 3.4"
   spec.add_dependency "sqlite3", "~> 2.0"
   spec.add_dependency "telegram-bot-ruby", "~> 2.7"
   spec.add_dependency "thor", "~> 1.3"
diff --git a/install.sh b/install.sh
index bd8f6e2d..fcc622e4 100755
--- a/install.sh
+++ b/install.sh
@@ -15,7 +15,7 @@ usage: install.sh [--dry-run] [--prefix=<dir>] [--version=<tag>]
 
 Installs hive as a rubygem (\`hive-cli\`) from GitHub Releases. The .gem
 is signed with cosign keyless attestation against this repo's release
-workflow; verification fails closed when cosign is available.
+workflow; cosign is required and verification fails closed.
 
 After install the \`hive\` and \`hv\` executables are symlinked into
 \${XDG_BIN_HOME:-~/.local/bin}. The installer also runs \`hive daemon install\`
@@ -25,7 +25,7 @@ telegram-bot-ruby) live under \${HIVE_PREFIX:-~/.local/share}/hive/gems so an
 uninstall is a clean \`rm -rf\` plus symlink removal.
 
 Requires Ruby 3.4 already on PATH; the installer reports its own
-prereqs (\`curl\`, \`jq\`, checksum tool) on first run. When npm is
+prereqs (\`curl\`, \`jq\`, \`cosign\`, checksum tool) on first run. When npm is
 available, the installer also installs Hive's qmd wiki indexer into the
 Hive data directory and links it beside the \`hive\` executable. Set
 HIVE_INSTALL_QMD=0 to skip that step.
@@ -177,6 +177,10 @@ sha256_cmd() {
 
 install_hint() {
   local dep="$1"
+  if [[ "$dep" == "cosign" ]]; then
+    printf 'follow https://docs.sigstore.dev/cosign/system_config/installation/'
+    return
+  fi
   case "$(uname -s)" in
     Darwin) printf 'brew install %s' "$dep" ;;
     Linux)
@@ -195,7 +199,11 @@ install_hint() {
 # crashing mid-curl / mid-gem-install with a confusing trace.
 installer_preflight() {
   local dep missing=0
-  for dep in curl jq; do
+  local -a dependencies=(curl jq)
+  if [[ "$DRY_RUN" -ne 1 ]]; then
+    dependencies+=(cosign)
+  fi
+  for dep in "${dependencies[@]}"; do
     if ! command -v "$dep" >/dev/null 2>&1; then
       warn "missing installer prerequisite '${dep}' ($(install_hint "$dep"))"
       missing=1
@@ -429,33 +437,21 @@ trap 'rm -rf "$tmpdir"' EXIT
 download_with_status "$gem_url" "${tmpdir}/${gem_file}" "release gem"
 download_with_status "$checksums_url" "${tmpdir}/SHA256SUMS" "SHA256SUMS"
 
-# Cosign verify SHA256SUMS when both the signature blob and the
-# keyless cert are published — release.yml writes both. We skip the
-# verification only when cosign isn't installed; missing signature
-# files are an attestable regression and we fail closed.
-if command -v cosign >/dev/null 2>&1; then
-  download_with_status "$sig_url" "${tmpdir}/SHA256SUMS.sig" "SHA256SUMS.sig"
-  download_with_status "$cert_url" "${tmpdir}/SHA256SUMS.pem" "SHA256SUMS.pem"
-  # Pin the keyless identity to OUR release workflow rather than `.*`.
-  # `.*` regexps would accept any GHA OIDC token from any repo —
-  # neutering the signature check. The identity must match the
-  # release.yml workflow path under ivankuznetsov/hive (allowing
-  # forks under HIVE_REPO_OWNER/HIVE_REPO_NAME via env). The issuer
-  # is GitHub Actions' Fulcio OIDC endpoint.
-  cosign verify-blob \
-    --certificate "${tmpdir}/SHA256SUMS.pem" \
-    --signature "${tmpdir}/SHA256SUMS.sig" \
-    --certificate-identity-regexp "^https://github\\.com/${REPO_OWNER}/${REPO_NAME}/" \
-    --certificate-oidc-issuer "https://token.actions.githubusercontent.com" \
-    "${tmpdir}/SHA256SUMS" \
-    || die "cosign verify-blob failed for SHA256SUMS (identity must match ${REPO_OWNER}/${REPO_NAME} release workflow)"
-else
-  # Phrased as a positive info line, not a scare-warning: the SHA256 check still
-  # runs (see below). cosign is an optional second factor for keyless signature
-  # verification — installing it upgrades the check; not having it doesn't break
-  # the install.
-  log "verifying release with SHA256 (install cosign for additional keyless signature verification)"
-fi
+# The checksum manifest and archive share one download channel, so the digest
+# alone is not an authenticity boundary. Require cosign and pin the exact
+# release workflow identity/tag before trusting any manifest entry.
+command -v cosign >/dev/null 2>&1 ||
+  die "missing prerequisite: cosign (install from https://docs.sigstore.dev/cosign/system_config/installation/)"
+download_with_status "$sig_url" "${tmpdir}/SHA256SUMS.sig" "SHA256SUMS.sig"
+download_with_status "$cert_url" "${tmpdir}/SHA256SUMS.pem" "SHA256SUMS.pem"
+cosign verify-blob \
+  --certificate "${tmpdir}/SHA256SUMS.pem" \
+  --signature "${tmpdir}/SHA256SUMS.sig" \
+  --certificate-identity \
+    "https://github.com/${REPO_OWNER}/${REPO_NAME}/.github/workflows/release.yml@refs/tags/${version}" \
+  --certificate-oidc-issuer "https://token.actions.githubusercontent.com" \
+  "${tmpdir}/SHA256SUMS" \
+  || die "cosign verify-blob failed for SHA256SUMS (identity must match ${REPO_OWNER}/${REPO_NAME} release workflow)"
 
 # Strict line match: optional `./` prefix, sha digest, two-space sep,
 # exact gem_file, optional CR. `|| true` so a no-match under `set -e`
diff --git a/lib/hive.rb b/lib/hive.rb
index b22bfe0e..3c17deac 100644
--- a/lib/hive.rb
+++ b/lib/hive.rb
@@ -30,6 +30,7 @@ module Hive
       "hive-daemon-enroll" => 1,
       "hive-daemon-reload" => 1,
       "hive-daemon-install" => 1,
+      "hive-daemon-maintenance" => 1,
       # Read-only inspection of the daemon's dispatch-request queue
       # (`hive daemon queue [list|show|prune]`). See AN-1/2/3 and
       # `Hive::Commands::Daemon#queue_command`.
@@ -57,6 +58,9 @@ module Hive
       "hive-bot-stop" => 1,
       "hive-bot-reload" => 1,
       "hive-bot-install" => 1,
+      "hive-setup" => 1,
+      "hive-web-install" => 1,
+      "hive-web-status" => 1,
       # File-backed dispatch request the bot writes for the daemon to
       # consume. One JSON file per pending request under the state-home
       # `dispatch_requests/` directory. See
diff --git a/lib/hive/agent_profile.rb b/lib/hive/agent_profile.rb
index 770f4b9e..8ee43b81 100644
--- a/lib/hive/agent_profile.rb
+++ b/lib/hive/agent_profile.rb
@@ -1,5 +1,6 @@
 require "open3"
 require "timeout"
+require "hive/bounded_process"
 
 module Hive
   # Per-CLI invocation contract for a headless agent.
@@ -235,9 +236,9 @@ module Hive
       # credentials or hang on first run. Without this, spawn_agent's
       # preflight could block indefinitely outside the per-stage timeout.
       begin
-        out, _err, status = Timeout.timeout(VERSION_CHECK_TIMEOUT_SEC) do
-          Open3.capture3(bin, @version_flag)
-        end
+        out, _err, status = Hive::BoundedProcess.capture3(
+          bin, @version_flag, timeout: VERSION_CHECK_TIMEOUT_SEC
+        )
       rescue Errno::ENOENT, Errno::EACCES => e
         raise Hive::AgentError, "#{@name} binary not runnable: #{bin} (#{e.class.name.split('::').last}: #{e.message})"
       rescue Timeout::Error
diff --git a/lib/hive/bounded_process.rb b/lib/hive/bounded_process.rb
new file mode 100644
index 00000000..6b5f5fbf
--- /dev/null
+++ b/lib/hive/bounded_process.rb
@@ -0,0 +1,102 @@
+require "open3"
+require "timeout"
+
+module Hive
+  module BoundedProcess
+    POLL_INTERVAL = 0.05
+    TERMINATE_GRACE = 0.2
+
+    module_function
+
+    def capture3(*argv, env: {}, chdir: nil, timeout:)
+      options = { pgroup: true }
+      options[:chdir] = chdir if chdir
+      started = monotonic
+
+      Open3.popen3(env, *argv, **options) do |stdin, stdout, stderr, wait_thread|
+        stdin.close
+        stdout_reader = Thread.new { read_stream(stdout) }
+        stderr_reader = Thread.new { read_stream(stderr) }
+
+        wait_for(wait_thread, timeout, started)
+        [ stdout_reader.value, stderr_reader.value, wait_thread.value ]
+      rescue Timeout::Error
+        terminate_group(wait_thread.pid, wait_thread: wait_thread)
+        stdout_reader&.kill
+        stderr_reader&.kill
+        raise
+      end
+    end
+
+    def run(env, *argv, chdir:, timeout:, out: $stdout, err: $stderr)
+      pid = Process.spawn(env, *argv, chdir: chdir, pgroup: true, out: out, err: err)
+      started = monotonic
+      loop do
+        waited = Process.waitpid2(pid, Process::WNOHANG)
+        return waited.last.success? if waited
+
+        raise Timeout::Error, "subprocess timed out after #{timeout}s" if monotonic - started >= timeout
+
+        sleep POLL_INTERVAL
+      end
+    rescue Timeout::Error
+      terminate_group(pid)
+      raise
+    end
+
+    def wait_for(wait_thread, timeout, started)
+      loop do
+        return if wait_thread.join(POLL_INTERVAL)
+        raise Timeout::Error, "subprocess timed out after #{timeout}s" if monotonic - started >= timeout
+      end
+    end
+    private_class_method :wait_for
+
+    def terminate_group(pid, wait_thread: nil)
+      return unless pid
+
+      signal_group("TERM", pid)
+      deadline = monotonic + TERMINATE_GRACE
+      while monotonic < deadline
+        if wait_thread
+          return if wait_thread.join(POLL_INTERVAL)
+        else
+          return if process_gone?(pid)
+          sleep POLL_INTERVAL
+        end
+
+      end
+      signal_group("KILL", pid)
+      wait_thread ? wait_thread.join : Process.waitpid(pid)
+    rescue Errno::ECHILD, Errno::ESRCH
+      nil
+    end
+    private_class_method :terminate_group
+
+    def signal_group(signal, pid)
+      Process.kill(signal, -pid)
+    rescue Errno::ESRCH
+      nil
+    end
+    private_class_method :signal_group
+
+    def process_gone?(pid)
+      Process.waitpid(pid, Process::WNOHANG)
+    rescue Errno::ECHILD
+      true
+    end
+    private_class_method :process_gone?
+
+    def read_stream(stream)
+      stream.read
+    rescue IOError
+      ""
+    end
+    private_class_method :read_stream
+
+    def monotonic
+      Process.clock_gettime(Process::CLOCK_MONOTONIC)
+    end
+    private_class_method :monotonic
+  end
+end
diff --git a/lib/hive/cli.rb b/lib/hive/cli.rb
index cd809068..05969fc1 100644
--- a/lib/hive/cli.rb
+++ b/lib/hive/cli.rb
@@ -50,6 +50,25 @@ module Hive
     end
     map "--version" => :version
 
+    desc "setup", "Diagnose and provision local Hive daemon and web services"
+    option :no_bootstrap, type: :boolean, default: false,
+                          desc: "diagnose Hive-owned dependencies without installing them"
+    option :no_init, type: :boolean, default: false,
+                     desc: "do not initialize or enroll the current repository"
+    option :no_service, type: :boolean, default: false,
+                        desc: "prepare web dependencies but leave web execution foreground-only"
+    def setup
+      require "hive/commands/setup"
+      result = Hive::Commands::Setup.new(
+        project_root: Dir.pwd,
+        no_bootstrap: options[:no_bootstrap],
+        no_init: options[:no_init],
+        no_service: options[:no_service],
+        json: options[:json]
+      ).call
+      exit 1 unless result["ok"]
+    end
+
     desc "init [PROJECT_PATH]", "Bootstrap .hive-state (orphan hive/state branch); TTY-prompts for agents + limits"
     long_desc <<~DESC
       Initialises hive in PROJECT_PATH (defaults to the current directory):
@@ -337,10 +356,11 @@ module Hive
                                desc: "also remove XDG state and registered project .hive-state directories"
     def uninstall
       require "hive/commands/uninstall"
-      Hive::Commands::Uninstall.new(
+      result = Hive::Commands::Uninstall.new(
         purge: options[:purge],
         force_purge_state: options[:force_purge_state]
       ).call
+      exit result unless result.zero?
     end
 
     desc "migrate [PROJECT_PATH]", "Rename in-flight task folders from the pre-open-pr stage layout"
@@ -1037,7 +1057,7 @@ module Hive
       ).call
     end
 
-    desc "daemon SUBCOMMAND [PROJECT]", "Manage the hive daemon (start / stop / status / reload / tail / install / enable / disable / queue)"
+    desc "daemon SUBCOMMAND [PROJECT]", "Manage the hive daemon (start / stop / status / repair / restart / install / enable / disable / queue)"
     long_desc <<~DESC
       Subcommands:
         start [--detach] [--dry-run]      Run the dispatcher loop. Without
@@ -1045,6 +1065,11 @@ module Hive
         stop [--json]                     Send SIGTERM to the running daemon.
                                           --json emits hive-daemon-stop.v1.
         status [--json]                   Show running / not-running.
+        repair [--json]                   Safely reinstall the service using
+                                          this Hive binary. Refuses while
+                                          agent tasks are active.
+        restart [--json]                  Safely restart the service. Refuses
+                                          while agent tasks are active.
         reload [--json]                   Send SIGHUP to reload config.
                                           --json emits hive-daemon-reload.v1.
         tail                              Stream daemon.log.
@@ -1332,11 +1357,15 @@ module Hive
       ).call
     end
 
-    desc "web", "Run the hivebox web UI"
+    desc "web [SUBCOMMAND]", "Run local web or manage its service (install / start / stop / status)"
     option :bind, type: :string, desc: "override web.bind"
     option :port, type: :numeric, desc: "override web.port"
-    def web
-      if options[:json]
+    option :unsafe, type: :boolean, default: false,
+                    desc: "permit a non-loopback bind without configured owner/auth"
+    option :force, type: :boolean, default: false,
+                   desc: "for install: replace a drifted service definition after backup"
+    def web(subcommand = nil)
+      if options[:json] && subcommand.nil?
         require "json"
         message = "hive web has no JSON output (it runs a long-lived server). " \
                   "Use 'hive status --json' for machine-readable task data."
@@ -1355,7 +1384,11 @@ module Hive
       end
 
       require "hive/commands/web"
-      Hive::Commands::Web.new(bind: options[:bind], port: options[:port]).call
+      Hive::Commands::Web.new(
+        subcommand,
+        bind: options[:bind], port: options[:port], unsafe: options[:unsafe],
+        force: options[:force], json: options[:json]
+      ).call
     end
 
     desc "tui", "Open the live, keystroke-driven dashboard for every active task"
diff --git a/lib/hive/commands/daemon.rb b/lib/hive/commands/daemon.rb
index 6c91610b..66e7ce93 100644
--- a/lib/hive/commands/daemon.rb
+++ b/lib/hive/commands/daemon.rb
@@ -37,7 +37,7 @@ module Hive
       include Hive::Schemas::EnvelopeEmitter
       include Hive::PidFile
 
-      VALID_SUBCOMMANDS = %w[start stop status reload tail enable disable install queue].freeze
+      VALID_SUBCOMMANDS = %w[start stop status reload tail enable disable install repair restart queue].freeze
 
       # Actions for `hive daemon queue ACTION` (AN-1/2/3). `list` is the
       # default when no action is given.
@@ -86,6 +86,7 @@ module Hive
         when "reload"           then reload_daemon
         when "tail"             then tail_daemon
         when "install"          then install_daemon
+        when "repair", "restart" then maintain_daemon
         when "queue"            then queue_command
         when "enable", "disable" then call_with_envelope { do_call }
         end
@@ -355,46 +356,33 @@ module Hive
       end
 
       def status_daemon
-        running = false
-        pid = nil
-        uptime_sec = nil
-
-        if File.exist?(pid_file)
-          payload = read_pid_file_payload
-          pid = payload && payload["pid"]
-          if pid && pid > 0 && pid_alive?(pid) && pid_owned_by_us?(payload, pid)
-            running = true
-            stat = File.stat(pid_file)
-            uptime_sec = (Time.now - stat.mtime).to_i
-          end
-        end
+        require "hive/daemon/status_report"
+        require "hive/commands/daemon/service_installer"
+        report = Hive::Daemon::StatusReport.new(
+          installer: Hive::Commands::Daemon::ServiceInstaller.new,
+          pid_probe: self,
+          pid_file: pid_file,
+          log_file: log_file
+        ).to_h
 
         if @json
-          service_state = probe_service_state
           puts JSON.generate(
             "schema" => "hive-daemon-status",
             "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-daemon-status"),
             "ok" => true,
-            "running" => running,
-            "pid" => running ? pid : nil,
-            "uptime_sec" => uptime_sec,
-            "pid_file" => pid_file,
-            "log_file" => log_file,
-            "service_installed" => service_state["service_installed"],
-            "service_enabled" => service_state["service_enabled"],
-            "unit_path" => service_state["unit_path"],
+            **report,
             # Agent-native parity with the TUI footer / bot push: expose the
             # update nudge so a programmatic caller can detect "behind" too.
-            "current_version" => Hive::VERSION,
             "update_nudge" => update_nudge_payload
           )
-        elsif running
-          puts "hive daemon: running (pid #{pid}, uptime #{uptime_sec}s)"
+        elsif report["running"]
+          puts "hive daemon: running (pid #{report['pid']}, uptime #{report['uptime_sec']}s)"
+          puts "hive daemon: service drift=#{report['drift']}" unless report["drift"] == "none"
         else
-          puts "hive daemon: not running"
+          puts "hive daemon: not running (service drift=#{report['drift']})"
         end
         # Exit code: 0 for running, 1 for not running (per plan U8)
-        raise Hive::Error, "daemon not running" unless running
+        raise Hive::Error, "daemon not running" unless report["running"]
       end
 
       # Read-only autostart-state snapshot for the status envelope. A status
@@ -561,6 +549,33 @@ module Hive
         emit_install_outcome(installer, result)
       end
 
+      # Fixed, machine-readable maintenance primitives shared with the web
+      # status page. Both actions fail closed when status cannot prove that
+      # no agents are active, so a unit repair/restart cannot silently tear
+      # down in-flight work.
+      def maintain_daemon
+        require "hive/commands/daemon/service_installer"
+        require "hive/web/daemon_maintenance"
+        installer = Hive::Commands::Daemon::ServiceInstaller.new(
+          binary_path: current_binary_path
+        )
+        result = Hive::Web::DaemonMaintenance.new(installer: installer).call(@subcommand)
+        payload = {
+          "schema" => "hive-daemon-maintenance",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-daemon-maintenance")
+        }.merge(result)
+        if @json
+          puts JSON.generate(payload)
+        elsif result["ok"]
+          puts "hive daemon: #{result['message']}"
+        else
+          warn "hive daemon: #{result['message']}"
+        end
+        raise Hive::Error, result["message"] unless result["ok"]
+
+        payload
+      end
+
       # Bare-text positive confirmation on the non-JSON success path
       # so operators can distinguish first-time install / no-op /
       # in-place upgrade at a glance. Mirrors what `reload_daemon`
@@ -671,7 +686,7 @@ module Hive
       end
 
       def current_binary_path
-        Hive::InvokedBinary.path
+        Hive::InvokedBinary.path || File.expand_path("../../../bin/hive", __dir__)
       end
 
       def safe_install_platform(installer)
diff --git a/lib/hive/commands/doctor.rb b/lib/hive/commands/doctor.rb
index 99afbc08..46f0c4ec 100644
--- a/lib/hive/commands/doctor.rb
+++ b/lib/hive/commands/doctor.rb
@@ -3,6 +3,7 @@ require "open3"
 require "timeout"
 
 require "hive"
+require "hive/bounded_process"
 require "hive/config"
 require "hive/agent_profiles"
 require "hive/agent_profiles/claude"
@@ -119,7 +120,7 @@ module Hive
         end
 
         begin
-          out, err, status = Timeout.timeout(15) { Open3.capture3(qmd, "--version") }
+          out, err, status = Hive::BoundedProcess.capture3(qmd, "--version", timeout: 15)
         rescue Timeout::Error, SystemCallError => e
           return [ warning_row(
             stage: "wiki",
diff --git a/lib/hive/commands/service_installer/base.rb b/lib/hive/commands/service_installer/base.rb
index 04f9ba76..7fbfcbba 100644
--- a/lib/hive/commands/service_installer/base.rb
+++ b/lib/hive/commands/service_installer/base.rb
@@ -2,6 +2,7 @@ require "cgi"
 require "fileutils"
 require "hive/install_channel"
 require "hive/commands/service_installer/outcome"
+require "hive/bounded_process"
 require "rbconfig"
 require "shellwords"
 
@@ -19,7 +20,7 @@ module Hive
         attr_reader :messages
 
         def initialize(host_os: RbConfig::CONFIG["host_os"], home: nil, binary_path: nil, runner: nil,
-                       systemctl_available: nil, launchctl_available: nil)
+                       systemctl_available: nil, launchctl_available: nil, capture_runner: nil)
           @host_os = host_os
           # Anchor on the real user home for launchd/systemd paths —
           # HIVE_HOME is a config/test override that does not apply
@@ -29,6 +30,9 @@ module Hive
           @home = File.expand_path(home || ENV["HOME"] || Dir.home)
           @binary_path = binary_path
           @runner = runner || ->(argv) { system(*argv, out: File::NULL) }
+          @capture_runner = capture_runner || lambda { |argv|
+            Hive::BoundedProcess.capture3(*argv, timeout: 3)
+          }
           @systemctl_available = systemctl_available
           @launchctl_available = launchctl_available
           @messages = []
@@ -87,6 +91,66 @@ module Hive
           "local.#{service_name}"
         end
 
+        def start!
+          case platform
+          when :linux
+            return false unless systemctl_available?
+            @runner.call([ "systemctl", "--user", "start", service_name ])
+          when :macos
+            return false unless launchctl_available?
+            @runner.call([ "launchctl", "start", launchd_label ])
+          else
+            false
+          end
+        end
+
+        def stop!
+          case platform
+          when :linux
+            return true unless systemctl_available?
+            @runner.call([ "systemctl", "--user", "stop", service_name ])
+          when :macos
+            return true unless launchctl_available?
+            @runner.call([ "launchctl", "stop", launchd_label ])
+          else
+            true
+          end
+        end
+
+        def running?
+          case platform
+          when :linux
+            systemctl_available? &&
+              !!@runner.call([ "systemctl", "--user", "is-active", "--quiet", service_name ])
+          when :macos
+            return false unless launchctl_available?
+
+            stdout, _stderr, status = @capture_runner.call([ "launchctl", "list", launchd_label ])
+            return false unless status.success?
+
+            text = stdout.to_s
+            table_pid = text.lines.first.to_s.strip.split(/\s+/).first
+            table_pid.match?(/\A\d+\z/) || text.match?(/["']?PID["']?\s*=\s*\d+/)
+          else
+            false
+          end
+        rescue SystemCallError, Timeout::Error
+          false
+        end
+
+        def service_manager_available?
+          case platform
+          when :linux then !!systemctl_available?
+          when :macos then !!launchctl_available?
+          else false
+          end
+        end
+
+        def unit_readable?
+          path = target_path
+          !path.nil? && File.file?(path) && File.readable?(path)
+        end
+
         # ── Subclass hooks ─────────────────────────────────────────────
         # Subclasses MUST override these. The base raises so a missing
         # override fails loudly rather than rendering a half-built unit.
@@ -293,6 +357,12 @@ module Hive
           "Environment=PATH=#{base.join(':')}"
         end
 
+        def launchd_path
+          build_path_line.delete_prefix("Environment=PATH=")
+                         .gsub("%h", @home)
+                         .sub(":/usr/local/bin", ":/opt/homebrew/bin:/usr/local/bin")
+        end
+
         def ruby_shim_dir
           ruby_path = which("ruby")
           return nil unless ruby_path
